#ifndef _MAX_LINUX_TYPES_
#define _MAX_LINUX_TYPES_


#ifdef __KERNEL__
#include <linux/types.h>
#else
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#ifdef __cplusplus
#include <exception>
#endif
#include <dirent.h>
#endif

#define _stdcall
#define __stdcall
#define __cdecl
#define VOID void
#define PVOID void*
#define HANDLE void*
#define CHAR char
#define UCHAR unsigned char
#define PUCHAR unsigned char *
#define WCHAR char
#define SHORT short
#define USHORT unsigned short
#define PUSHORT unsigned short *
#define ULONG unsigned long
#define PULONG unsigned long *
#define LONG long
#define BOOLEAN short
#define BOOL short
#define DWORD unsigned long
#define HMODULE void *
#define BYTE unsigned char
#define UINT unsigned int
#define LPVOID void *
#define BASETYPES

#ifndef __KERNEL__
#define MAX_PATH PATH_MAX


typedef union _LARGE_INTEGER
{
    struct
    {
        unsigned long LowPart;
        long HighPart;
    }u;
//! s64 QuadPart;
    long long QuadPart;
}
LARGE_INTEGER;


/*************************************/
/* types and functions for directory */
/* accesses                          */
/*************************************/
typedef struct _finddata_t
{
  char name[MAX_PATH];
    char mask[MAX_PATH];
  unsigned long dwFileAttributes;
} _find_data;

int _findfirst(char *mask, struct _finddata_t *ffblk);
int _findnext(int hFile, struct _finddata_t *ffblk);
int _findclose(int hFile);
/*************************************/
#endif

#define PINTERFACE_REFERENCE void *
#define PINTERFACE_DEREFERENCE void *

#define IN
#define OUT
#define FAR // %&$!

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef INFINITE
#define INFINITE 0xffff
#endif

#ifndef DLL_PROCESS_ATTACH
#define DLL_PROCESS_ATTACH 0x0001
#define DLL_THREAD_ATTACH  0x0002
#define DLL_THREAD_DETACH  0x0004
#define DLL_PROCESS_DETACH 0x0008
#endif

#ifndef ACCESS_TYPE_MEMORY
#define ACCESS_TYPE_IO 0x0001
#define ACCESS_TYPE_MEMORY 0x0002
#endif

#ifndef BUSTYPE_PCI
#define BUSTYPE_ISA 0x0001
#define BUSTYPE_PCI 0x0005
#define BUSTYPE_USB 0x0003
#endif

#ifndef INVALID_HANDLE_VALUE
#define INVALID_HANDLE_VALUE -1
#endif

#ifndef FILE_ATTRIBUTE_DIRECTORY
#define FILE_ATTRIBUTE_FILE      0x0001
#define FILE_ATTRIBUTE_DIRECTORY 0x0002
#endif

#ifndef FIELD_OFFSET
typedef long INT_PTR, *PINT_PTR;
#define FIELD_OFFSET(type, field)    ((LONG)(INT_PTR)&(((type *)0)->field))
#endif

//wrappers
#define Sleep(ms) usleep(1000*(ms))
#ifdef _DEBUG
#define OutputDebugString(msg) fprintf(stderr,"%s",(msg))
#else
#define OutputDebugString(msg)
#endif
#define  _stricmp(a,b) strncasecmp((a),(b),MAX_PATH)
#define GetCurrentDirectory(a,b) getcwd((b),(a))

#define TlsGetValue pthread_getspecific
#define TlsFree pthread_key_delete
#define TlsSetValue pthread_setspecific

#define RegCloseKey(a) CloseRootNode((a),NULL,0)
#define GetCurrentProcessId()  (int)getpid()



#endif //_MAX_LINUX_TYPES_
