/********************************************************************
*  MAX_LIB.H
*
*  This header file declares the prototypes of the SORCUS libraries
*  for the MAX-system.
*
*  Copyrights:          SORCUS Computer GmbH 2001
*                       All Rights Reserved
********************************************************************/

#ifndef _INC_X_PROT_H
#define _INC_X_PROT_H

#ifdef PLATFORM_LINUX //CB 11.11.2003
#include <linuxtypes.h>
#endif

#include "x_types.h"

#if defined(__cplusplus)
extern "C" {
#endif

/********************************************************************/
/* Functions that do not access a particular MAX-CPU module         */
/********************************************************************/
MAXAPI MAX_ERROR MAXEXPORT max_init_lib (USHORT usLanguage);
MAXAPI MAX_ERROR MAXEXPORT max_exit_lib (void);
MAXAPI void		  MAXEXPORT max_get_lib_version (MAX_VERSION *pVersion, ULONG *pulDate);
MAXAPI MAX_ERROR MAXEXPORT max_get_drv_version (MAX_VERSION *pVersion, ULONG *pulDate);
MAXAPI void      MAXEXPORT max_get_version_string (MAX_VERSION ulVersion, ULONG ulDate, 
												   char *szVersion, char *szDate);
MAXAPI MAX_ERROR MAXEXPORT max_scan_boards (USHORT *pusTotalNumber, 
											MAX_CONNECTION_TYPE *prcBoardList);
MAXAPI MAX_ERROR MAXEXPORT max_get_board_info (USHORT usCard, MAX_BOARD_TYPE *prcInfo);
MAXAPI MAX_ERROR MAXEXPORT max_get_module_info (USHORT usCard, USHORT usSlot, USHORT usLayer,
												MAX_MODULINFO_TYPE *prcModulInfo);
MAXAPI MAX_ERROR MAXEXPORT max_board_reacting (USHORT usCard);
MAXAPI MAX_ERROR MAXEXPORT max_reset_board (USHORT usCard, USHORT usTimeout);
MAXAPI MAX_ERROR MAXEXPORT max_set_timeout (USHORT usCard, USHORT usTimeout);
MAXAPI MAX_ERROR MAXEXPORT max_set_board_led (USHORT usCard, USHORT usLed, USHORT usOnOff);
MAXAPI ULONG	  MAXEXPORT	max_get_physical_addr (void *ptr);
MAXAPI void		  MAXEXPORT max_clear_error (void);
MAXAPI MAX_ERROR MAXEXPORT max_get_error_message (MAX_ERROR Error, 
												  USHORT *pusSize, char *szMessage);
MAXAPI MAX_ERROR MAXEXPORT max_connect_modules (
                               MAX_VIL_CONNECT_TYPE *prcConnection,
                               MAX_VIL_RESULT_TYPE *prcResult);

/********************************************************************/
/* MISCELLANEOUS FUNCTIONS for a cpu module    			              */	
/********************************************************************/

MAXAPI MAX_ERROR MAXEXPORT max_connect_cpu (USHORT usCard, USHORT usSlot, USHORT usLayer,
											MAX_OS_INFO *prcOs, MAXMODHND *hModul);
MAXAPI MAX_ERROR MAXEXPORT max_get_os_version (MAXMODHND hModul, MAX_OS_INFO *prcOs);
MAXAPI MAX_ERROR MAXEXPORT max_exit_cpu (MAXMODHND *hModul);
MAXAPI MAX_ERROR MAXEXPORT max_load_osx (MAXMODHND hModul, char *sOsX);
MAXAPI MAX_ERROR MAXEXPORT max_reacting (MAXMODHND hModul);
MAXAPI MAX_ERROR MAXEXPORT max_allocate_ram (MAXMODHND hModul, MAX_ALLOC_TYPE *prcMemory,
											 ULONG *pulSize, ULONG *pulPhysAddr);
MAXAPI MAX_ERROR MAXEXPORT max_read_memory (MAXMODHND hModul, ULONG ulPhysAddr,
											ULONG *pulSize, void *pData);
MAXAPI MAX_ERROR MAXEXPORT max_write_memory (MAXMODHND hModul, ULONG ulPhysAddr,
											 ULONG *pulSize, void *pData);
MAXAPI MAX_ERROR MAXEXPORT max_get_ram_info (MAXMODHND hModul, MAX_RAM_TYPE *prcInfo);
MAXAPI MAX_ERROR MAXEXPORT max_set_service (MAXMODHND hModul, MAX_CALLBACK_TYPE pfnService);
MAXAPI MAX_ERROR MAXEXPORT max_get_max_blocksize (MAXMODHND hModul, 
												  ULONG *pulReceive, ULONG *pulTransmit);
MAXAPI MAX_ERROR MAXEXPORT max_get_slot (MAXMODHND hModul, USHORT *pusSlot, USHORT *pusLayer);
MAXAPI MAX_ERROR MAXEXPORT max_macro_interruptible (MAXMODHND hModul, USHORT usMacroCtrl);

/********************************************************************/
/* FUNCTIONS FOR TASK-COMMUNICATION                                 */	
/********************************************************************/
MAXAPI MAX_ERROR MAXEXPORT max_transfer_and_install (MAXMODHND hModul, 
													 MAX_PGM_TYPE *prcProgram,
													 USHORT *pusTask);
MAXAPI MAX_ERROR MAXEXPORT max_transfer_program (MAXMODHND hModul, 
												 char *sFileName, USHORT usProgNo,
												 ULONG *pulStartAddr);
MAXAPI MAX_ERROR MAXEXPORT max_install_task (MAXMODHND hModul, 
											 MAX_PGM_TYPE *prcTaskInfo, 
											 ULONG ulAddress,
											 USHORT *pusTask);
MAXAPI MAX_ERROR MAXEXPORT max_get_prog_version (MAXMODHND hCard, USHORT usTask,
												 MAX_VERSION *pVersion, ULONG *pulDate);
MAXAPI MAX_ERROR MAXEXPORT max_wakeup_ii_task (MAXMODHND hModul, USHORT usTask); 
MAXAPI MAX_ERROR MAXEXPORT max_wakeup_ni_task (MAXMODHND hModul, USHORT usTask, 
											   USHORT usOption); 
MAXAPI MAX_ERROR MAXEXPORT max_wakeup_ti_task (MAXMODHND hModul, USHORT usTask, 
											   MAX_TI_TYPE *prcTaskInfo); 
MAXAPI MAX_ERROR MAXEXPORT max_sleep_task (MAXMODHND hModul, USHORT usTask);
MAXAPI MAX_ERROR MAXEXPORT max_get_task_status (MAXMODHND hModul, 
											    USHORT usTask, USHORT *pusStatus);
MAXAPI MAX_ERROR MAXEXPORT max_call_proc (MAXMODHND hModul, 
										  USHORT usTask, USHORT usProc);
MAXAPI MAX_ERROR MAXEXPORT max_call_func (MAXMODHND hModul, 
										  USHORT usTask, USHORT usProc,
										  USHORT *pusDataInSize, void *pDataIn,
										  USHORT *pusDataOutSize, void *pDataOut);
MAXAPI MAX_ERROR MAXEXPORT max_task_info (MAXMODHND hModul, USHORT usTask, 
										  USHORT usInfoType, ULONG *pulResult);
MAXAPI MAX_ERROR MAXEXPORT max_get_task_number_prog (MAXMODHND hModul, 
										   			 USHORT usPgmNo, 
													 USHORT *pusInstance,
													 USHORT *pusTaskNo);
MAXAPI MAX_ERROR MAXEXPORT max_get_task_number_int (MAXMODHND hModul, USHORT usInterrupt, USHORT *pusTaskNo);
MAXAPI MAX_ERROR MAXEXPORT max_get_data_sema (MAXMODHND hModul, USHORT usTask);
MAXAPI MAX_ERROR MAXEXPORT max_release_data_sema (MAXMODHND hModul, USHORT usTask);
MAXAPI MAX_ERROR MAXEXPORT max_get_data (MAXMODHND hModul, 
 										 USHORT usTask, ULONG ulOffset, 
										 ULONG *pulSize, void *pData);
MAXAPI MAX_ERROR MAXEXPORT max_set_data (MAXMODHND hModul, 
										 USHORT usTask, ULONG ulOffset, 
										 ULONG *pulSize, void *pData);
MAXAPI MAX_ERROR MAXEXPORT max_get_par_sema (MAXMODHND hModul, USHORT usTask);
MAXAPI MAX_ERROR MAXEXPORT max_release_par_sema (MAXMODHND hModul, USHORT usTask);
MAXAPI MAX_ERROR MAXEXPORT max_read_par_uchar (MAXMODHND hModul, USHORT usTask, 
										 	   USHORT usOffset, UCHAR *pucPar);
MAXAPI MAX_ERROR MAXEXPORT max_read_par_ushort (MAXMODHND hModul, USHORT usTask, 
											    USHORT usOffset, USHORT *pusPar);
MAXAPI MAX_ERROR MAXEXPORT max_read_par_ulong (MAXMODHND hModul, USHORT usTask, 
											   USHORT usOffset, ULONG *pulPar);
MAXAPI MAX_ERROR MAXEXPORT max_read_par_block (MAXMODHND hModul,
											   USHORT usTask, USHORT usOffset, 
											  USHORT *pusSize, void *pPar);
MAXAPI MAX_ERROR MAXEXPORT max_write_par_uchar (MAXMODHND hModul, USHORT usTask, 
											    USHORT usOffset, UCHAR ucPar);
MAXAPI MAX_ERROR MAXEXPORT max_write_par_ushort (MAXMODHND hModul, USHORT usTask, 
											     USHORT usOffset, USHORT usPar);
MAXAPI MAX_ERROR MAXEXPORT max_write_par_ulong (MAXMODHND hModul, USHORT usTask, 
												USHORT usOffset, ULONG ulPar);
MAXAPI MAX_ERROR MAXEXPORT max_write_par_block (MAXMODHND hModul,
												USHORT usTask, USHORT usOffset, 
												USHORT *pusSize, void *pPar);

/********************************************************************/
/* FUNCTIONS FOR BUFFER-ACCESS										        */	
/********************************************************************/

MAXAPI MAX_ERROR MAXEXPORT max_create_buffer (MAXMODHND hModul, 
											  MAX_BUFFER_TYPE *prcBufferParam, 
											  ULONG *pulSize, MAXBUFHND *pHandle);
MAXAPI MAX_ERROR MAXEXPORT max_get_buffer_id (MAXBUFHND hBuffer, ULONG *pulID);
MAXAPI MAX_ERROR MAXEXPORT max_get_buffer_handle (MAXMODHND hModul, ULONG ulID, 
												  MAXBUFHND *pHandle);
MAXAPI MAX_ERROR MAXEXPORT max_delete_buffer (MAXBUFHND *phBuffer);
MAXAPI MAX_ERROR MAXEXPORT max_clear_buffer (MAXBUFHND hBuffer);
MAXAPI MAX_ERROR MAXEXPORT max_get_buffer_status (MAXBUFHND hBuffer, ULONG *pulValid, ULONG *pulFree);
MAXAPI MAX_ERROR MAXEXPORT max_get_buffer (MAXBUFHND hBuffer, USHORT usStrategy, 
										   ULONG *pulSize, void *pData);
MAXAPI MAX_ERROR MAXEXPORT max_set_buffer (MAXBUFHND hBuffer, USHORT usStrategy, 
										   ULONG *pulSize, void *pData);

/********************************************************************/
/* I/O AND HARDWARE FUNCTIONS    										     */	
/********************************************************************/
MAXAPI MAX_ERROR MAXEXPORT max_get_flash_info (MAXMODHND hModul, USHORT usSlot, USHORT usLayer,  
											   USHORT usIC, MAX_FLASH_TYPE *prcInfo);
MAXAPI MAX_ERROR MAXEXPORT max_flash_sector_info (MAXMODHND hModul, USHORT usSlot, USHORT usLayer,
												  USHORT usIC, USHORT usSector, 
												  USHORT *pusProtection);
MAXAPI MAX_ERROR MAXEXPORT max_erase_flash (MAXMODHND hModul, USHORT usSlot, 
											USHORT usLayer, USHORT usIC, 
											ULONG ulStartAddr, ULONG ulEndAddr);
MAXAPI MAX_ERROR MAXEXPORT max_write_flash (MAXMODHND hModul, USHORT usSlot, 
											USHORT usLayer, USHORT usIC, 
											ULONG ulStartAddr, ULONG ulSize, void *pData);
MAXAPI MAX_ERROR MAXEXPORT max_read_flash (MAXMODHND hModul, USHORT usSlot, 
										   USHORT usLayer, USHORT usIC, 
										   ULONG ulStartAddr, ULONG ulSize, void *pData);

/*********************************************************************/
/* FUNCTIONS FOR MODULE DEVICE DRIVER COMMUNICATION						*/
/*********************************************************************/

MAXAPI MAX_ERROR MAXEXPORT max_load_mdd (MAXMODHND hModul, USHORT usSlot, 
										 USHORT usLayer, USHORT usSubModule, 
										 USHORT usProgNo, MAX_PGM_TYPE *prcProgram, 
										 MAXMDDHND *hMdd);
MAXAPI MAX_ERROR MAXEXPORT max_open_channel (MAXMDDHND hMdd, 
											 USHORT usCpsSize, void *pCPS, 
											 MAX_CHANNEL_CALLBACK_TYPE pCbFunc, 
											 ULONG ulPar, MAXCHLHND *hChannel);
MAXAPI MAX_ERROR MAXEXPORT max_export_channel_handle(MAXMODHND hModul, USHORT usTask, 
													 USHORT usFuncNo, MAXCHLHND *hChannel);
MAXAPI MAX_ERROR MAXEXPORT max_convert_channel_handle (MAX_CHANNEL_TRANSFER_TYPE *prcChannelData,
													   MAXCHLHND *hChannel);
MAXAPI MAX_ERROR MAXEXPORT max_read_infotext (MAXMDDHND hMdd, USHORT usPage, USHORT usLine, 
											  USHORT *pusMaxSize, char *sText);
MAXAPI MAX_ERROR MAXEXPORT max_device_status (MAXMDDHND hMdd, MAX_DEV_SPEC_TYPE *prcDevice, 
											  USHORT *pusStatus);
MAXAPI MAX_ERROR MAXEXPORT max_get_mdd_version (MAXMDDHND hMdd, 
												MAX_VERSION *pVersion, ULONG *pulDate);
MAXAPI MAX_ERROR MAXEXPORT max_reset_mdd (MAXMDDHND hMdd);
MAXAPI MAX_ERROR MAXEXPORT max_read_channel_uchar (MAXCHLHND hChannel, UCHAR *pucData);
MAXAPI MAX_ERROR MAXEXPORT max_read_channel_ushort (MAXCHLHND hChannel, USHORT *pusData);
MAXAPI MAX_ERROR MAXEXPORT max_read_channel_short (MAXCHLHND hChannel, SHORT *psData);
MAXAPI MAX_ERROR MAXEXPORT max_read_channel_ulong (MAXCHLHND hChannel, ULONG *pulData);
MAXAPI MAX_ERROR MAXEXPORT max_read_channel_long (MAXCHLHND hChannel, LONG *plData);
MAXAPI MAX_ERROR MAXEXPORT max_read_channel_block (MAXCHLHND hChannel,
																	ULONG *pulSize, void *pData);
MAXAPI MAX_ERROR MAXEXPORT max_trigger_channel (MAXCHLHND hChannel);
MAXAPI MAX_ERROR MAXEXPORT max_write_channel_uchar (MAXCHLHND hChannel, UCHAR ucData);
MAXAPI MAX_ERROR MAXEXPORT max_write_channel_ushort (MAXCHLHND hChannel, USHORT usData);
MAXAPI MAX_ERROR MAXEXPORT max_write_channel_short (MAXCHLHND hChannel, SHORT sData);
MAXAPI MAX_ERROR MAXEXPORT max_write_channel_ulong (MAXCHLHND hChannel, ULONG ulData);
MAXAPI MAX_ERROR MAXEXPORT max_write_channel_long (MAXCHLHND hChannel, LONG lData);
MAXAPI MAX_ERROR MAXEXPORT max_write_channel_block (MAXCHLHND hChannel, 
													ULONG *pulSize, void *pData);
MAXAPI MAX_ERROR MAXEXPORT max_channel_control (MAXCHLHND hChannel, USHORT usCmd, 
												USHORT usSize, void *pData);
MAXAPI MAX_ERROR MAXEXPORT max_channel_info (MAXCHLHND hChannel, USHORT usInfo, 
											 USHORT *pusSize, void *pData);
MAXAPI MAX_ERROR MAXEXPORT max_close_channel (MAXCHLHND *hChannel);
MAXAPI MAX_ERROR MAXEXPORT max_set_mdd_path (const char *pszPath);
MAXAPI MAX_ERROR MAXEXPORT max_get_mdd_path (char *pszPath);
MAXAPI MAX_ERROR MAXEXPORT max_get_channel_id (MAXCHLHND hChannel, ULONG *pulID);

/*********************************************************************/
/* Funcions to access the hardware devices on the CPU-module			*/
/*********************************************************************/
MAXAPI MAX_ERROR MAXEXPORT max_get_rtc_status (MAXMODHND hModul, USHORT *pusStatus);
MAXAPI MAX_ERROR MAXEXPORT max_set_rtc_mode (MAXMODHND hModul, USHORT usMode);
// status of RTC interrupts:
// Bit 7: Interrupt Request (set if interrupt any of the RTC interrupts occured)
// Bit 6: Periodic Interrupt (set wether interrupt is enabled or not)
// Bit 5: Alarm Interrupt (set wether interrupt is enabled or not)
// Bit 4: Update Ended Interrupt (set wether interrupt is enabled or not)
MAXAPI MAX_ERROR MAXEXPORT max_get_rtc_interrupt_status (MAXMODHND hCard, UCHAR *pucStatus);
MAXAPI MAX_ERROR MAXEXPORT max_get_date_and_time (MAXMODHND hModul, MAX_TIME_TYPE *prcTime);
MAXAPI MAX_ERROR MAXEXPORT max_set_date_and_time (MAXMODHND hModul, MAX_TIME_TYPE *prcTime);
MAXAPI MAX_ERROR MAXEXPORT max_get_alarm (MAXMODHND hModul, MAX_ALARM_TYPE *prcTime);
MAXAPI MAX_ERROR MAXEXPORT max_set_alarm (MAXMODHND hModul, MAX_ALARM_TYPE *prcTime);
MAXAPI MAX_ERROR MAXEXPORT max_write_cmos (MAXMODHND hModul, USHORT usAddr, 
										   USHORT usSize, void *pData);
MAXAPI MAX_ERROR MAXEXPORT max_read_cmos (MAXMODHND hModul, USHORT usAddr, 
										  USHORT usSize, void *pData);
MAXAPI MAX_ERROR MAXEXPORT max_led_on (MAXMODHND hModul);
MAXAPI MAX_ERROR MAXEXPORT max_led_off (MAXMODHND hModul);
MAXAPI MAX_ERROR MAXEXPORT max_led_status (MAXMODHND hModul, USHORT *pusStatus);
MAXAPI MAX_ERROR MAXEXPORT max_cache_control (MAXMODHND hModul, USHORT *pusMode);
MAXAPI MAX_ERROR MAXEXPORT max_init_module (MAXMODHND hModul, USHORT usSlot, 
											USHORT usLayer, USHORT usMode);
MAXAPI MAX_ERROR MAXEXPORT max_cpu_speed_control(MAXMODHND hModul,
                                                 USHORT usMode, USHORT usSpeed);

/*********************************************************************/
// EEPROM Access
/*********************************************************************/
MAXAPI MAX_ERROR MAXEXPORT max_get_eeprom_info (USHORT usCard, USHORT usSlot, 
															   USHORT usLayer, MAX_EEPINFO_TYPE *prcInfo);
// max_write_eeprom is for direct access do not use it 															   
MAXAPI MAX_ERROR MAXEXPORT max_write_eeprom (USHORT usCard, USHORT usSlot, 
															USHORT usLayer, ULONG  ulOffset, 
															ULONG  ulSize, void *pData);
// max_read_eeprom is for direct access do not use it 															   
MAXAPI MAX_ERROR MAXEXPORT max_read_eeprom (USHORT usCard, USHORT usSlot, 
															USHORT usLayer, ULONG  ulOffset, 
															ULONG  ulSize, void *pData);
MAXAPI MAX_ERROR MAXEXPORT max_open_eeprom (USHORT usCard, USHORT usSlot, 
														  USHORT usLayer, USHORT usFlags);
MAXAPI MAX_ERROR MAXEXPORT max_close_eeprom (USHORT usCard, USHORT usSlot, 
														   USHORT usLayer, USHORT usFlags);
MAXAPI MAX_ERROR MAXEXPORT max_get_free_eeprom_block (USHORT usCard, USHORT usSlot, 
																		USHORT usLayer, ULONG *pulSize);
MAXAPI MAX_ERROR MAXEXPORT max_create_eeprom_area (USHORT usCard, USHORT usSlot, 
																	USHORT usLayer, USHORT usUsage,
																	USHORT usSize, USHORT usFlags);
MAXAPI MAX_ERROR MAXEXPORT max_delete_eeprom_area (USHORT usCard, USHORT usSlot, 
																	USHORT usLayer, USHORT usUsage, 
																	char *sPass);
MAXAPI MAX_ERROR MAXEXPORT max_get_eeprom_area_size (USHORT usCard, USHORT usSlot, 
																	  USHORT usLayer, USHORT usUsage,
																	  USHORT *pusSize);
MAXAPI MAX_ERROR MAXEXPORT max_write_eeprom_area (USHORT usCard, USHORT usSlot, 
																  USHORT usLayer, USHORT usUsage,
																  USHORT usOffset, USHORT usSize, 
																  void *pData, char *sPass);
MAXAPI MAX_ERROR MAXEXPORT max_read_eeprom_area (USHORT usCard,  
																 USHORT usSlot, USHORT usLayer, 
																 USHORT usUsage, USHORT usOffset, 
																 USHORT usSize, void *pData, char *sPass);

/*********************************************************************/
// direct I/O access for cpu-devices that are not supported by other software
// read or write a single byte/word/dword from/into the io-address usPort
// describtion in the file ioports.pdf
/*********************************************************************/
MAXAPI MAX_ERROR MAXEXPORT max_read_io_byte (MAXMODHND hModul, USHORT usPort, UCHAR *pucData);
MAXAPI MAX_ERROR MAXEXPORT max_read_io_word (MAXMODHND hModul, USHORT usPort, USHORT *pusData);
MAXAPI MAX_ERROR MAXEXPORT max_read_io_long (MAXMODHND hModul, USHORT usPort, ULONG *pulData);
MAXAPI MAX_ERROR MAXEXPORT max_write_io_byte (MAXMODHND hModul, USHORT usPort, UCHAR ucData);
MAXAPI MAX_ERROR MAXEXPORT max_write_io_word (MAXMODHND hModul, USHORT usPort, USHORT usData);
MAXAPI MAX_ERROR MAXEXPORT max_write_io_long (MAXMODHND hModul, USHORT usPort, ULONG ulData);
MAXAPI MAX_ERROR MAXEXPORT max_read_io_indexed (MAXMODHND hModul, USHORT usPort,
												UCHAR ucIndex, UCHAR *pucData);
MAXAPI MAX_ERROR MAXEXPORT max_write_io_indexed (MAXMODHND hCard, USHORT usPort,
												 UCHAR ucIndex, UCHAR ucAndMask,
												 UCHAR ucOrMask);

/*********************************************************************/
/* Conversion FUNCTIONS FOR visual basic					         */
/*********************************************************************/
MAXAPI void MAXEXPORT ConvertLongToMaxLong(ULONG ulLongValue, MAX_LONG *prcMaxLong);
MAXAPI ULONG MAXEXPORT ConvertMaxLongToLong(MAX_LONG *prcMaxLong); 
MAXAPI void MAXEXPORT ConvertIntToMaxInt(USHORT usIntValue, MAX_INT *prcMaxInt);
MAXAPI USHORT MAXEXPORT ConvertMaxIntToInt(MAX_INT *prcMaxInt); 


#ifdef _WIN32_WCE
    MAXAPI MAX_ERROR MAXEXPORT max_get_version(ULONG ulInfoType, MAX_VERSION *pulVersion);
#endif


#ifdef _RTLIB_

/*********************************************************************/
/* FUNCTIONS FOR RT-programs only             						      */
/*********************************************************************/
MAXAPI USHORT    MAXEXPORT max_entry_proc (void);
MAXAPI void		  MAXEXPORT max_exit_proc (void);
MAXAPI USHORT	  MAXEXPORT max_entry_func (void);
MAXAPI void		  MAXEXPORT max_exit_func (MAX_ERROR Error);
MAXAPI USHORT    MAXEXPORT max_entry_proc_di (void);
MAXAPI void		  MAXEXPORT max_exit_proc_ei (void);
MAXAPI USHORT	  MAXEXPORT max_entry_func_di (void);
MAXAPI void		  MAXEXPORT max_exit_func_ei (MAX_ERROR Error);
MAXAPI MAX_ERROR MAXEXPORT max_init_program (MAX_PDT_HEAD *prcPDT);
MAXAPI MAX_ERROR MAXEXPORT max_send_srq (MAXMODHND hModul, USHORT usMode, USHORT usData);
MAXAPI void*	 MAXEXPORT max_get_real_addr (ULONG ulPhysAddr);
MAXAPI MAX_ERROR MAXEXPORT max_clear_int (MAXMODHND hModul, USHORT usIrq);
MAXAPI MAX_ERROR MAXEXPORT max_mask_int (MAXMODHND hModul, USHORT usIrq);
MAXAPI MAX_ERROR MAXEXPORT max_unmask_int (MAXMODHND hModul, USHORT usIrq);
MAXAPI MAX_ERROR MAXEXPORT max_get_nmi_reason (MAXMODHND hModul, USHORT *pusReason);
MAXAPI MAX_ERROR MAXEXPORT max_trigger_watchdog (MAXMODHND hModul);
MAXAPI MAX_ERROR MAXEXPORT max_set_timer (MAXMODHND hModul, USHORT usTimer, USHORT usMode, USHORT usValue);
MAXAPI MAX_ERROR MAXEXPORT max_get_timer (MAXMODHND hModul, USHORT usTimer, MAX_TIMER_STATE_TYPE *prcTimer);
MAXAPI void		 MAXEXPORT max_disable_int(void);
MAXAPI void		 MAXEXPORT max_enable_int(void);
MAXAPI MAX_ERROR MAXEXPORT max_get_int_vector(UCHAR Irq, void *pfnISR);
MAXAPI MAX_ERROR MAXEXPORT max_set_int_vector(UCHAR Irq, void *pfnISR);
MAXAPI MAX_ERROR MAXEXPORT max_set_osx_func (USHORT usNo, ULONG ulAddr);
MAXAPI void		 MAXEXPORT max_set_error_check_level (USHORT usLevel);

#else
/*********************************************************************/
/* FUNCTIONS FOR Host-PC-programs only             						      */
/*********************************************************************/
MAXAPI MAX_ERROR MAXEXPORT max_get_mini_os_error (MAXMODHND hModul);
MAXAPI MAX_ERROR MAXEXPORT max_execute_ins_file (MAXMODHND hModul, char *szInsFile,
												 USHORT usMode); 
// this function downloads an ins-file and all realtimeprograms included in the ins-file
// into the flash specified by hModul, usSlot, usLayer, usIC. 
// It uses the library a_xmodule.dll from the SNW32\bin directory.
MAXAPI MAX_ERROR MAXEXPORT max_write_ins_file_to_flash (MAXMODHND hModul, 
														USHORT usSlot, USHORT usLayer, 
														USHORT usIC, char *szInsFileName,
														USHORT usMode); 
#endif

#if defined(__cplusplus)
}
#endif

#endif // _INC_X_PROT_H
